clear
clf
g0=9.8;l=1;k0=0.02;m=0.1;k_gain=4;a1=1;
Tfinal=10;
Td=0.0001;
t=0:Td:Tfinal;
N=length(t);

x(1,1)=-pi/2+0.1;x(2,1)=0;u(1)=0;ref(1)=pi/2;
for k=2:N
    x(1,k)=x(1,k-1)+Td*x(2,k-1);
    x(2,k)=x(2,k-1)+Td*(-(g0/l)*sin(x(1,k-1)+ref(k-1))-(k0/m)*x(2,k-1)+(1/(m*l*l))*u(k-1));
    s(k-1)=a1*x(1,k-1)+x(2,k-1);
    u(k)=-k_gain*sign(a1*x(1,k-1)+x(2,k-1));
    %u(k)=-k_gain*sat(a1*x(1,k-1)+x(2,k-1),0.3);
    ref(k)=ref(k-1);
end
figure(1)
plot(t,x(1,:)+ref(1),t,ref)
axis([0 8 0 2])
figure(2)
plot(t,u)
axis([0 2.5 -5 5])
figure(3)
plot(t(1:N-1),s)
